剑指offer-37、数字在升序数组中出现的次数

题目描述

统计⼀个数字在升序数组中出现的次数。

示例1 输⼊:1,2,3,3,3,3,4,5,3 返回值:4

思路及解答

线性遍历

顺序遍历数组,遇到目标值就计数

java 复制代码
public class Solution {

    public int GetNumberOfK(int[] array, int k) {
        if (array == null || array.length == 0) {
            return 0;
        }
        
        int count = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i] == k) {
                count++;
            }
            // 由于数组有序,如果当前元素已大于k,可提前结束
            else if (array[i] > k) {
                break;
            }
        }
        return count;
    }
}
  • 时间复杂度:O(n),最坏情况下需要遍历整个数组
  • 空间复杂度:O(1),只使用常数级别额外空间

二分查找+左右扫描法

先使用二分查找定位到目标值,然后向两边扩展统计。

由于数组是有序的,可以明显看到是二分法。

第1步是找出数值为 k 的数的索引: 假设数组为 nums\[\] ,⼀开始的左边索引为 left = 0 ,右边界索引为 right = nums.length-1

  1. 将数组分成两部分,中间的数为 numsmid 。第1部分为 left,mid ,第2部分为mid+1,right。
  2. 如果 numsmid>k ,则说明 k 只可能存在前半部分中,对前半部分执⾏操作1。
  3. 如果 numsmid<k ,则说明 k 只可能存在后半部分中,对后半部分执⾏操作1。
  4. 如果 numsmid=k ,直接返回当前索引 mid 。
  5. 如果 left > right ,说明 k 不存在,则返回 -1 。

找到索引之后,往两边扩展,同时统计k的个数,直到元素不等于 k 的时候停⽌。

java 复制代码
public class Solution {

    public int GetNumberOfK(int[] array, int k) {
        if (array == null || array.length == 0) return 0;
        
        int left = 0, right = array.length - 1;
        int count = 0;
        
        // 二分查找
        while (left <= right) {
            int mid = left + (right - left) / 2;
            
            if (array[mid] < k) {
                left = mid + 1;
            } else if (array[mid] > k) {
                right = mid - 1;
            } else {
                // 找到目标值,向左右扩展统计
                count = 1;
                int temp = mid;
                
                // 向左统计
                while (--temp >= left && array[temp] == k) {
                    count++;
                }
                
                // 向右统计
                temp = mid;
                while (++temp <= right && array[temp] == k) {
                    count++;
                }
                break;
            }
        }
        return count;
    }
}
  • 时间复杂度:O(log n + k),其中k是目标值出现次数。当目标值出现次数较少时效率接近O(log n),但最坏情况(全部是目标值)退化为O(n)
  • 空间复杂度:O(1)

双二分查找法(推荐)

分别使用二分查找找到目标值的起始和结束位置,计算区间长度,这是最优解法。

java 复制代码
public class Solution {

    public int GetNumberOfK(int[] array, int k) {
        if (array == null || array.length == 0) return 0;
        
        // 找到第一个k的位置
        int firstIndex = findFirstPosition(array, k);
        // 找到最后一个k的位置
        int lastIndex = findLastPosition(array, k);
        
        if (firstIndex == -1 || lastIndex == -1) {
            return 0; // 目标值不存在
        }
        
        return lastIndex - firstIndex + 1;
    }
    
    /**
     * 查找目标值的第一个出现位置
     */
    private int findFirstPosition(int[] array, int k) {
        int left = 0, right = array.length - 1;
        
        while (left <= right) {
            int mid = left + (right - left) / 2;
            
            if (array[mid] < k) {
                left = mid + 1;
            } else if (array[mid] > k) {
                right = mid - 1;
            } else {
                // 关键:检查是否为第一个出现位置
                if (mid == 0 || array[mid - 1] != k) {
                    return mid;
                } else {
                    right = mid - 1; // 继续在左半部分查找
                }
            }
        }
        return -1; // 未找到
    }
    
    /**
     * 查找目标值的最后一个出现位置
     */
    private int findLastPosition(int[] array, int k) {
        int left = 0, right = array.length - 1;
        
        while (left <= right) {
            int mid = left + (right - left) / 2;
            
            if (array[mid] < k) {
                left = mid + 1;
            } else if (array[mid] > k) {
                right = mid - 1;
            } else {
                // 关键:检查是否为最后一个出现位置
                if (mid == array.length - 1 || array[mid + 1] != k) {
                    return mid;
                } else {
                    left = mid + 1; // 继续在右半部分查找
                }
            }
        }
        return -1; // 未找到
    }
}
  • 时间复杂度:O(log n),执行两次二分查找
  • 空间复杂度:O(1),只使用常数空间

k±0.5边界查找法

一种巧妙的解法,通过查找目标值边界的插入位置来计算出现次数。

由于数组元素都是整数,k-0.5和k+0.5正好是目标值范围的边界,它们的插入位置差值就是目标值出现次数

java 复制代码
public class Solution {

    public int GetNumberOfK(int[] array, int k) {
        if (array == null || array.length == 0) return 0;
        
        // 查找k+0.5的插入位置(第一个大于k的位置)
        int upperBound = findInsertPosition(array, k + 0.5);
        // 查找k-0.5的插入位置(第一个大于等于k的位置)
        int lowerBound = findInsertPosition(array, k - 0.5);
        
        return upperBound - lowerBound;
    }
    
    /**
     * 在有序数组中查找目标值的插入位置
     */
    private int findInsertPosition(int[] array, double target) {
        int left = 0, right = array.length - 1;
        
        while (left <= right) {
            int mid = left + (right - left) / 2;
            
            if (array[mid] < target) {
                left = mid + 1;
            } else {
                right = mid - 1;
            }
        }
        return left; // 返回插入位置
    }
}
  • 时间复杂度:O(log n),两次二分查找
  • 空间复杂度:O(1)
相关推荐
w_zero_one2 小时前
递归算法(一)
java·开发语言·算法
SL_staff2 小时前
私有化低代码不是减配版开发:JVS双模式建模如何重建IT交付信任
java·低代码·spring cloud
墨着染霜华2 小时前
Redocly 生成 OpenAPI 接口文档踩坑实录|Node 版本兼容 + 接口地址错误问题解决
java
文丑颜不良啊2 小时前
LeetCode1881~1990题目解析
java·leetcode
十碗饭吃不饱3 小时前
后端运维:网络联通、进程查询、Java服务启动脚本
java·运维·网络
T_Wizard3 小时前
后端转 AI 应用开发,我先把这 12 个名词理清了:一张图看懂架构、RAG、Tool Calling 与 MCP
java·ai编程
杨航 AI4 小时前
JEV的用法
java·前端·数据库
灿飞4 小时前
Kotlin与Java虚拟机七:空安全:把十亿美元的错误消灭在类型系统里
java·kotlin
知识搬运临时工4 小时前
JVM 删掉偏向锁之后,一次无竞争锁从 0.3 纳秒变成 5.4 纳秒
java
IT枫斗者枫哥4 小时前
用了BigDecimal还差一分?用四组Java代码查清原因
java·后端